"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _events = require("events");

var _store = _interopRequireWildcard(require("./store"));

var _dbContext = _interopRequireDefault(require("../db-context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class CustomItem extends _events.EventEmitter {
  constructor(guid, ownerGuid, options = {}) {
    super();

    _defineProperty(this, "useSelector", selector => {
      return selector(this.store.getState());
    });

    _defineProperty(this, "dispatch", action => {
      return this.store.dispatch(action);
    });

    _defineProperty(this, "getState", () => {
      return this.getPublicState(this.store.getState());
    });

    _defineProperty(this, "emitState", (force = false) => {
      if (force) {
        this.emit('state', this.getState());
      }

      if (this.stopEmission) {
        return;
      }

      if (this.useSelector(_store.selectIsForeground)) {
        this.emit('state', this.getState());
      }
    });

    this.dbContext = options.dbContext || new _dbContext.default();
    this.dbContextIsLocal = options.dbContext == null;
    this.store = (0, _store.default)();
    this.store.dispatch((0, _store.setGuid)(guid));
    this.store.dispatch((0, _store.setOwnerGuid)(ownerGuid));
    this.stopEmission = false;
  }

  getPublicState() {
    return {
      guid: this.useSelector(_store.selectGuid),
      ownerGuid: this.useSelector(_store.selectOwnerGuid),
      status: this.useSelector(_store.selectStatus)
    };
  }

}

var _default = CustomItem;
exports.default = _default;