"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.selectToolbarCommandsArray = exports.addToolbarCommands = exports.addToolbarCommand = void 0;

var _toolkit = require("@reduxjs/toolkit");

const slice = (0, _toolkit.createSlice)({
  name: 'toolbarCommands',
  initialState: {
    toolbarCommands: []
  },
  reducers: {
    addToolbarCommand: (state, action) => {
      const stateRef = state;
      stateRef.toolbarCommands = [...state.toolbarCommands, action.payload];
    },
    addToolbarCommands: (state, action) => {
      var _action$payload;

      const stateRef = state;
      stateRef.toolbarCommands = [...state.toolbarCommands, ...((_action$payload = action.payload) !== null && _action$payload !== void 0 ? _action$payload : [])];
    }
  }
});
const {
  addToolbarCommand,
  addToolbarCommands
} = slice.actions;
exports.addToolbarCommands = addToolbarCommands;
exports.addToolbarCommand = addToolbarCommand;

const selectToolbarCommandsArray = state => state.toolbarCommands.toolbarCommands;

exports.selectToolbarCommandsArray = selectToolbarCommandsArray;
var _default = slice.reducer;
exports.default = _default;